## unity-scopes-api 1.0.4+16.04.20160402.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.10)

# Default install location. Must be set here, before setting the project.
if (NOT DEFINED CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
endif()

set(PROJECT unity-scopes-api)
project(${PROJECT} C CXX)

if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
   message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
endif()

include(CheckCXXSourceCompiles)
CHECK_CXX_SOURCE_COMPILES("#ifdef __clang__\n#else\n#error \"Not clang.\"\n#endif\nint main(int argc, char **argv) { return 0; }" IS_CLANG)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

if(IS_CLANG)
  message(STATUS "Compiling with Clang, disabling lttng.")
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower) # Build types should always be lowercase but sometimes they are not.

set(ACCEPTED_BUILD_TYPES "" none release debug relwithdebinfo coverage)
list(FIND ACCEPTED_BUILD_TYPES "${cmake_build_type_lower}" IS_BUILD_TYPE_ACCEPTED)
if(${IS_BUILD_TYPE_ACCEPTED} EQUAL -1)
  message(FATAL_ERROR "Invalid CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}\nValid types are: ${ACCEPTED_BUILD_TYPES}")
endif()

# Static C++ checks

find_program(CPPCHECK_COMMAND NAMES cppcheck)
if (CPPCHECK_COMMAND)
    set(CPPCHECK_COMMAND_OPTIONS --check-config --inline-suppr --enable=all -q --error-exitcode=2)
    set(CPPCHECK_COMMAND_OPTIONS ${CPPCHECK_COMMAND_OPTIONS} --template "'{file}({line}): {severity} ({id}): {message}'")
    add_custom_target(cppcheck COMMAND ${CPPCHECK_COMMAND} ${CPPCHECK_COMMAND_OPTIONS}
        ${CMAKE_SOURCE_DIR}/src
        ${CMAKE_SOURCE_DIR}/test
        ${CMAKE_BINARY_DIR}/test
    )
else()
    message(WARNING "Cannot find cppcheck: cppcheck target will not be available")
endif()

#
# Definitions for testing with valgrind.
#

configure_file(CTestCustom.cmake.in CTestCustom.cmake) # Tests in CTestCustom.cmake are skipped for valgrind

find_program(MEMORYCHECK_COMMAND NAMES valgrind)
if (MEMORYCHECK_COMMAND)
    set(MEMORYCHECK_COMMAND_OPTIONS
        "--suppressions=${CMAKE_SOURCE_DIR}/valgrind-suppress --leak-check=full --num-callers=40 --error-exitcode=3"
    )
    add_custom_target(valgrind DEPENDS NightlyMemCheck)
else()
    message(WARNING "Cannot find valgrind: valgrind target will not be available")
endif()

include(FindPkgConfig)
find_package(Boost COMPONENTS system filesystem regex serialization thread REQUIRED)
pkg_check_modules(UNITY_API libunity-api>=0.1.3 REQUIRED)
pkg_check_modules(PROCESS_CPP process-cpp>=1.0.1 REQUIRED)
pkg_check_modules(APPARMOR REQUIRED libapparmor REQUIRED)
pkg_check_modules(LTTNG_UST lttng-ust REQUIRED)
pkg_check_modules(LIBURCU_BP liburcu-bp REQUIRED)
pkg_check_modules(JSONCPP jsoncpp REQUIRED)
pkg_check_modules(LIBACCOUNTS libaccounts-glib REQUIRED)
pkg_check_modules(LIBSIGNON libsignon-glib REQUIRED)
pkg_check_modules(ZMQLIB libzmq REQUIRED)
pkg_check_modules(NET_CPP net-cpp>=1.2.0 REQUIRED)

find_library(ZMQPPLIB zmqpp)
if(NOT ZMQPPLIB)
  message(FATAL_ERROR "libzmqpp-dev not found.")
endif()

find_library(CAPNPLIB capnp)
if(NOT CAPNPLIB)
  message(FATAL_ERROR "libcapnp-dev not found.")
endif()

find_library(KJLIB kj)
if(NOT KJLIB)
  message(FATAL_ERROR "capnproto not found.")
endif()

find_library(DLLIB dl)
if(NOT DLLIB)
  message(FATAL_ERROR "dl lib not found.")
endif()

find_program(LTTNG_EXECUTABLE lttng)
if (NOT LTTNG_EXECUTABLE)
    message(SEND_ERROR "Cannot find LTTng executable: ensure that lttng-tools is installed")
endif()

#
# Code style fixer. We put the code through astyle first because it makes some fixes that
# clang-format won't do (such as "char *p" -> "char* p"). But astyle messes up other things
# (particularly lambdas and assembly-style comments), which clang-format does right.
# So, we run clang-format after running astyle, which undoes the damage done by astyle
# without reverting desirable astyle fixes.
#

find_program(ASTYLE_COMMAND NAMES astyle)
if (NOT ASTYLE_COMMAND)
    message(WARNING "Cannot find astyle: formatcode target will not be available")
else()
    # astyle 2.03 creates DOS line endings, so we need to fix its output
    find_program(DOS2UNIX_COMMAND NAMES dos2unix)
    if (NOT DOS2UNIX_COMMAND)
        message(WARNING "Cannot find dos2unix: formatcode target will not be available")
    else()
        # Some time after clang-format-3.6, someone finally decided to install the versioned
        # /usr/bin/clang-format binary name as /usr/bin/clang-format (without the version suffix).
        find_program(CLANG_FORMAT_COMMAND NAMES clang-format clang-format-3.6 clang-format-3.5)
        if (NOT CLANG_FORMAT_COMMAND)
            message(WARNING "Cannot find clang-format >= clang-format-3.5: formatcode target will not be available")
        endif()
    endif()
endif()

if (ASTYLE_COMMAND AND DOS2UNIX_COMMAND AND CLANG_FORMAT_COMMAND)
set(UNITY_SCOPES_LIB_HDRS ${UNITY_SCOPES_LIB_HDRS} ${fmt_h})
    add_custom_target(formatcode
                      ${PROJECT_SOURCE_DIR}/tools/format-files.sh ${PROJECT_SOURCE_DIR} ${ASTYLE_COMMAND} ${CLANG_FORMAT_COMMAND})
endif()

find_program(CAPNPC_BIN capnpc)
if(NOT CAPNPC_BIN)
  message(FATAL_ERROR "Capnp compiler not found.")
endif()
set(CAPNPC_FLAGS "" CACHE STRING "Extra flags for capnpc.")

add_definitions(
  -DDEB_HOST_MULTIARCH="${CMAKE_LIBRARY_ARCHITECTURE}"
)

set(OTHER_INCLUDE_DIRS ${OTHER_INCLUDE_DIRS} ${UNITY_API_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS}
                       ${JSONCPP_INCLUDE_DIRS} ${PROCESS_CPP_INCLUDE_DIRS} ${APPARMOR_INCLUDE_DIRS}
                       ${LIBACCOUNTS_INCLUDE_DIRS} ${LIBSIGNON_INCLUDE_DIRS} ${NET_CPP_INCLUDE_DIRS})
set(OTHER_LIBS ${OTHER_LIBS} ${UNITY_API_LDFLAGS} ${APPARMOR_LDFLAGS} ${LIBACCOUNTS_LIBRARIES}
               ${LIBSIGNON_LIBRARIES} ${Boost_LIBRARIES} ${JSONCPP_LDFLAGS} ${PROCESS_CPP_LDFLAGS}
               ${ZMQPPLIB} ${ZMQLIB_LDFLAGS} ${CAPNPLIB} ${KJLIB} ${DLLIB} ${NET_CPP_LDFLAGS} pthread)

# Standard install paths
include(GNUInstallDirs)

include_directories(
    include/
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_BINARY_DIR}/src
    ${OTHER_INCLUDE_DIRS}
)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wno-variadic-macros -Wextra -fPIC")

# By default, all symbols are visible in the library. We strip out things we don't
# want at link time, by running a version script (see unity-scopes.map and the
# setting of LINK_FLAGS below).
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=default")

set(C_AND_CXX_WARNINGS "-pedantic -Wall -Wextra")

# Some additional warnings not included by the general flags set above.
set(EXTRA_C_WARNINGS "-Wcast-align -Wcast-qual -Wformat -Wredundant-decls -Wswitch-default")
set(EXTRA_CXX_WARNINGS "-Wnon-virtual-dtor -Wctor-dtor-privacy -Wold-style-cast")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${C_AND_CXX_WARNINGS}")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_C_WARNINGS}")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 ${C_AND_CXX_WARNINGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_C_WARNINGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_CXX_WARNINGS}")

# -fno-permissive causes warnings with clang, so we only enable it for gcc
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-permissive")
endif()

if ("${cmake_build_type_lower}" STREQUAL "release" OR "${cmake_build_type_lower}" STREQUAL "relwithdebinfo")
    option(Werror "Treat warnings as errors" ON)
else()
    option(Werror "Treat warnings as errors" OFF)
endif()

# Some tests are slow, so make it possible not to run them during day-to-day development.
# The default for this *must* stay ON, otherwise the tests won't run in Jenkins.
option(slowtests "Run slow tests" ON)

if (${Werror})
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
    if ("${cmake_build_type_lower}" STREQUAL "release" OR "${cmake_build_type_lower}" STREQUAL "relwithdebinfo")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error=deprecated-declarations")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=deprecated-declarations")
    endif()
endif()

set(SANITIZER "" CACHE STRING "Build with -fsanitize=<value> (legal values: thread, address)")

if ("${SANITIZER}" STREQUAL "")
    # Do nothing
elseif (${SANITIZER} STREQUAL "thread")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=thread -fno-omit-frame-pointer")
elseif (${SANITIZER} STREQUAL "address")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
else()
    message(FATAL_ERROR "Invalid SANITIZER setting: ${SANITIZER}")
endif()

# Scopes library names. Also used as a prefix in various places, and as a subdirectory
# name for installed files. Changing this will also require corresponding changes
# to the debian files.
set(UNITY_SCOPES_LIB unity-scopes)
set(UNITY_SCOPES_QT_LIB unity-scopes-qt)

set(DEBIAN_DIR ${CMAKE_SOURCE_DIR}/debian)

# Set versions for libunity-scopes.
file(READ ${DEBIAN_DIR}/VERSION version)
string(REGEX MATCHALL "[0-9]+" version_list ${version})
list(GET version_list 0 UNITY_SCOPES_MAJOR)
list(GET version_list 1 UNITY_SCOPES_MINOR)
list(GET version_list 2 UNITY_SCOPES_MICRO)

set(UNITY_SCOPES_MAJOR_MINOR ${UNITY_SCOPES_MAJOR}.${UNITY_SCOPES_MINOR})
set(UNITY_SCOPES_FULL_VERSION ${UNITY_SCOPES_MAJOR_MINOR}.${UNITY_SCOPES_MICRO})

execute_process(COMMAND lsb_release -c -s OUTPUT_VARIABLE SERIES)
string(STRIP ${SERIES} SERIES)
if (${SERIES} STREQUAL "vivid")
    # For backward compatibility. On Vivid, the soname started counting at 3: libunity-scopes.so.3.
    math(EXPR UNITY_SCOPES_SOVERSION "${UNITY_SCOPES_MINOR} + 3")
else()
    # For Wily and later, the soname is libunity-scopes.so.<maj>.<min>, e.g. libunity-scopes.so.1.0.
    set(UNITY_SCOPES_SOVERSION ${UNITY_SCOPES_MAJOR_MINOR})
endif()

# Set versions for libunity-scopes-qt.
file(READ ${DEBIAN_DIR}/QT-VERSION version)
string(REGEX MATCHALL "[0-9]+" version_list ${version})
list(GET version_list 0 UNITY_SCOPES_QT_MAJOR)
list(GET version_list 1 UNITY_SCOPES_QT_MINOR)
list(GET version_list 2 UNITY_SCOPES_QT_MICRO)

set(UNITY_SCOPES_QT_MAJOR_MINOR ${UNITY_SCOPES_QT_MAJOR}.${UNITY_SCOPES_QT_MINOR})
set(UNITY_SCOPES_QT_FULL_VERSION ${UNITY_SCOPES_QT_MAJOR_MINOR}.${UNITY_SCOPES_QT_MICRO})
set(UNITY_SCOPES_QT_SOVERSION ${UNITY_SCOPES_QT_MAJOR_MINOR})

if(NOT ${UNITY_SCOPES_MAJOR} EQUAL 1)
    message(FATAL_ERROR "Change in major version number. You need to adjust bileto_pre_release_hook")
endif()

if(NOT ${UNITY_SCOPES_QT_MAJOR} EQUAL 0)
    message(FATAL_ERROR "Change in Qt major version number. You need to adjust bileto_pre_release_hook")
endif()

# Library for testing, with all symbols visible
set(UNITY_SCOPES_TEST_LIB ${UNITY_SCOPES_LIB}-test)

# All the libraries we need to link a normal executable that uses Unity scopes
set(LIBS ${UNITY_SCOPES_LIB})

# Test version of ${UNITY_SCOPES_LIB}, with internal symbols visible
set(TESTLIBS ${UNITY_SCOPES_TEST_LIB})

# Library install prefix
set(LIB_INSTALL_PREFIX lib/${CMAKE_LIBRARY_ARCHITECTURE})
set(LIBDIR ${CMAKE_INSTALL_LIBDIR})

set(LIBSUBDIR ${LIBDIR}/${UNITY_SCOPES_LIB}})
set(HDR_INSTALL_DIR include/${UNITY_SCOPES_LIB}-${UNITY_SCOPES_SOVERSION})

#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage (or ninja if you use that backend)
#  * Find html report in subdir coveragereport
#  * Find xml report suitable for jenkins in coverage.xml
#####################################################################
if(cmake_build_type_lower MATCHES coverage)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage -g")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage -g")

=== abi-compliance/CMakeLists.txt ===
configure_file(check-abi-compliance.sh.in ${CMAKE_CURRENT_BINARY_DIR}/check-abi-compliance.sh @ONLY)
configure_file(gen-abi-dump.sh.in ${CMAKE_CURRENT_BINARY_DIR}/gen-abi-dump.sh @ONLY)

set(abi_dump_cmd /bin/sh ${CMAKE_CURRENT_BINARY_DIR}/gen-abi-dump.sh)
set(abi_check_cmd /bin/sh ${CMAKE_CURRENT_BINARY_DIR}/check-abi-compliance.sh)
set(abi_dump_file ${CMAKE_CURRENT_BINARY_DIR}/lib${UNITY_SCOPES_LIB}_${UNITY_SCOPES_FULL_VERSION}.abi.xml)
set(abi_baseline_dump ${CMAKE_CURRENT_BINARY_DIR}/lib${UNITY_SCOPES_LIB}_${UNITY_SCOPES_MAJOR}.0.0.abi.xml)
set(abi_report ${CMAKE_CURRENT_BINARY_DIR}/lib${UNITY_SCOPES_LIB}_${UNITY_SCOPES_FULL_VERSION}_abi-report.txt)

add_custom_command(
    OUTPUT ${abi_dump_file}
    COMMAND ${abi_dump_cmd}
    DEPENDS ${UNITY_SCOPES_LIB})

add_custom_target(gen-abi-dump DEPENDS ${abi_dump_file})

add_custom_command(
    OUTPUT run_always ${abi_report}
    COMMAND ${abi_check_cmd}
    DEPENDS ${abi_dump_file} ${suppressions})
set_source_files_properties(run_always
    PROPERTIES SYMBOLIC true)
set_directory_properties(PROPERTIES
    ADDITIONAL_MAKE_CLEAN_FILES ${abi_baseline_dump})

add_custom_target(check-abi DEPENDS run_always)

add_test(check-abi-compliance ${CMAKE_MAKE_PROGRAM} check-abi)

=== autopkg/CMakeLists.txt ===
add_executable(scopetest ${CMAKE_SOURCE_DIR}/debian/tests/scopetest.cpp)
target_link_libraries(scopetest ${UNITY_SCOPES_LIB} ${OTHER_LIBS})

add_test(autopkg-scopetest scopetest)

=== click/CMakeLists.txt ===
add_subdirectory(scope-click)

=== gtest/CMakeLists.txt ===
if (NOT DEFINED GMOCK_ROOT)
    set(GMOCK_ROOT /usr/src/gmock)
endif()

add_subdirectory(${GMOCK_ROOT} gmock)

# Selectively switch off warnings about missing field initializers when building gmock and gtest
set_property(TARGET gmock APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-missing-field-initializers -Wno-old-style-cast")
set_property(TARGET gmock_main APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-missing-field-initializers -Wno-old-style-cast")
set_property(TARGET gtest APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-missing-field-initializers -Wno-old-style-cast")

# Make sure we always build gtest/gmock with debug info, otherwise we don't
# get line numbers for the code that is dragged in by the test macros.
set_property(TARGET gmock APPEND_STRING PROPERTY COMPILE_FLAGS " -g")
set_property(TARGET gmock_main APPEND_STRING PROPERTY COMPILE_FLAGS " -g")
set_property(TARGET gtest APPEND_STRING PROPERTY COMPILE_FLAGS " -g")

include_directories(${GMOCK_ROOT}/gtest/include)

set(LIBGTEST gtest gmock gmock_main)
set(TESTLIBS ${TESTLIBS} ${LIBGTEST} boost_regex)

add_subdirectory(scopes)

set(TEST_SRC
)

foreach(src ${TEST_SRC})
    get_filename_component(name ${src} NAME_WE)
    add_executable(${name} ${src})
    target_link_libraries(${name} ${TESTLIBS})
    string(REPLACE "_test" "" test_name ${name})
    add_test(${test_name} ${name})
endforeach(src)

=== headers/CMakeLists.txt ===
#
# Test that all header files compile stand-alone and that no public header includes an internal one.
#

set(root_inc_dir ${CMAKE_SOURCE_DIR}/include)

set(subdirs
    unity/scopes
    unity/scopes/qt
    unity/scopes/testing
    unity/scopes/utility
)
find_package(Qt5Core REQUIRED)

foreach(dir ${OTHER_INCLUDE_DIRS})
    set(other_inc_dirs "${other_inc_dirs} -I${dir}")
endforeach()

set(other_inc_dirs "${other_inc_dirs} -I${CMAKE_BINARY_DIR}/include -I${CMAKE_BINARY_DIR}")
set(qt_inc_dirs "-I${Qt5Core_INCLUDE_DIRS}")

# replace ; with -I as the include directories from Qt are set with ; in between
# different directories
string(REPLACE "//" " -I/" qt_inc_dirs ${qt_inc_dirs})

foreach(dir ${subdirs})
    string(REPLACE "/" "-" location ${dir})

    # check if the project path contains qt
    # If so add the flags needed to compile the qt files
    string(FIND ${dir} "qt" POS)
    set(qt_includes "")
    IF(NOT ${POS} MATCHES "-1")
        set(qt_includes "${qt_inc_dirs} -fPIC")
    ENDIF()

    set(public_inc_dir ${root_inc_dir}/${dir})
    set(internal_inc_dir ${public_inc_dir}/internal)

    # Test that each public header compiles stand-alone.
    add_test(stand-alone-${location}-headers
        ${CMAKE_CURRENT_SOURCE_DIR}/compile_headers.py
            ${public_inc_dir} ${CMAKE_CXX_COMPILER} "${CMAKE_CXX_COMPILER_ARG1} -fsyntax-only -I${root_inc_dir} -I${public_inc_dir} ${other_inc_dirs} ${CMAKE_CXX_FLAGS} ${qt_includes}")

    # Test that each internal header compiles stand-alone.
    if (IS_DIRECTORY ${internal_inc_dir})
        add_test(stand-alone-${location}-internal-headers
            ${CMAKE_CURRENT_SOURCE_DIR}/compile_headers.py
                ${internal_inc_dir} ${CMAKE_CXX_COMPILER} "${CMAKE_CXX_COMPILER_ARG1} -fsyntax-only -I${root_inc_dir} -I${internal_inc_dir} ${other_inc_dirs} ${CMAKE_CXX_FLAGS} ${qt_includes}")
    endif()

    # Test that no public header includes an internal header
    add_test(clean-public-${location}-headers ${CMAKE_CURRENT_SOURCE_DIR}/check_public_headers.py ${public_inc_dir})

endforeach()

add_test(cleanincludes ${CMAKE_CURRENT_SOURCE_DIR}/includechecker.py ${CMAKE_SOURCE_DIR}/include)
add_test(noglobalincludes ${CMAKE_CURRENT_SOURCE_DIR}/check_global_usage.py
         ${CMAKE_SOURCE_DIR}/include ${CMAKE_BINARY_DIR}/include)

=== scopes/CMakeLists.txt ===
add_subdirectory(utility)
add_subdirectory(internal)
add_subdirectory(testing)
add_subdirectory(qt)

set(CAPNPROTO_FILES ${CAPNPROTO_FILES} PARENT_SCOPE)

set(SRC
    ${CMAKE_CURRENT_SOURCE_DIR}/AbstractScopeBase.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ActionMetadata.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ActivationListenerBase.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ActivationQueryBase.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ActivationResponse.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Annotation.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/CannedQuery.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/CategorisedResult.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Category.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/CategoryRenderer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ChildScope.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ColumnLayout.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/CompletionDetails.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Department.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/DateTimePickerFilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/FilterBase.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/FilterGroup.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/FilterOption.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/FilterState.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Link.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ListenerBase.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Location.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Object.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/OnlineAccountClient.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/RangeInputFilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/OperationInfo.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/OptionSelectorFilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/PreviewListenerBase.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/PreviewQueryBase.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/PreviewReply.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/PreviewWidget.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QueryBase.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QueryCtrl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QueryMetadata.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/RadioButtonsFilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/RatingFilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Registry.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Reply.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Result.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Runtime.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ScopeBase.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Scope.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ScopeExceptions.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ScopeMetadata.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/SearchListenerBase.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/SearchMetadata.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/SearchQueryBase.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/SearchReply.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/SwitchFilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ValueSliderFilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ValueSliderLabels.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/VariantBuilder.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Variant.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Version.cpp
)
set(UNITY_SCOPES_LIB_SRC ${UNITY_SCOPES_LIB_SRC} ${SRC} PARENT_SCOPE)

=== stand-alone/CMakeLists.txt ===
configure_file(Runtime.ini.in Runtime.ini)

add_executable(stand-alone-client stand-alone-client.cpp)

# Add_dependencies should be used sparingly. In this case we need the global
# header to be generated before we start building the client binary, and
# we need an up-to-date registry to run it.
add_dependencies(stand-alone-client globalheader)
add_dependencies(stand-alone-client scoperegistry)
add_definitions(-DDEMO_RUNTIME_PATH="${CMAKE_CURRENT_BINARY_DIR}/Runtime.ini")
target_link_libraries(stand-alone-client ${UNITY_SCOPES_LIB} ${OTHER_LIBS})

=== gtest/scopes/CMakeLists.txt ===
add_subdirectory(internal)
add_subdirectory(testing)
add_subdirectory(utility)

if(${slowtests})
  add_subdirectory(stress)
endif()

add_subdirectory(Activation)
add_subdirectory(ActivationResponse)
add_subdirectory(Aggregation)
add_subdirectory(Annotation)
add_subdirectory(CannedQuery)
add_subdirectory(CategorisedResult)
add_subdirectory(Category)
add_subdirectory(CategoryRenderer)
add_subdirectory(ColumnLayout)
add_subdirectory(DateTimePickerFilter)
add_subdirectory(Department)
add_subdirectory(Filters)
add_subdirectory(IdleShutdown)
add_subdirectory(Invocation)
add_subdirectory(Location)
add_subdirectory(OnlineAccountClient)
add_subdirectory(OptionSelectorFilter)
add_subdirectory(PreviewWidget)
add_subdirectory(QueryMetadata)
add_subdirectory(RadioButtonsFilter)
add_subdirectory(RangeInputFilter)
add_subdirectory(RatingFilter)
add_subdirectory(Registry)
add_subdirectory(ReplyReaper)
add_subdirectory(ResultCache)
add_subdirectory(Runtime)
add_subdirectory(ScopeBase)
add_subdirectory(ScopeExceptions)
add_subdirectory(StandAloneScope)
add_subdirectory(StripLocation)
add_subdirectory(SwitchFilter)
add_subdirectory(ThrowingClient)
add_subdirectory(ThrowingScope)
add_subdirectory(ValueSliderFilter)
add_subdirectory(Variant)
add_subdirectory(VariantBuilder)
add_subdirectory(Version)
add_subdirectory(qt)

=== scopes/internal/CMakeLists.txt ===
add_subdirectory(lttng)
add_subdirectory(smartscopes)
add_subdirectory(zmq_middleware)
set(CAPNPROTO_FILES ${CAPNPROTO_FILES} PARENT_SCOPE)

set(SRC
    ${CMAKE_CURRENT_SOURCE_DIR}/AbstractObject.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ActionMetadataImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ActivationQueryBaseImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ActivationQueryObject.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ActivationReplyObject.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ActivationResponseImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/AnnotationImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/CannedQueryImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/CategorisedResultImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/CategoryImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/CategoryRegistry.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/CategoryRendererImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ChildScopesRepository.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ColumnLayoutImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/CompletionDetailsImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ConfigBase.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/DateTimePickerFilterImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/DepartmentImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/DynamicLoader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Executor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/FilterBaseImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/FilterGroupImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/FilterOptionImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/FilterStateImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IniSettingsSchema.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/JsonCppNode.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/JsonSettingsSchema.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/LinkImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/LocationImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Logger.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/MiddlewareBase.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/MiddlewareFactory.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/MWObject.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/MWPublisher.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/MWQuery.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/MWQueryCtrl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/MWRegistry.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/MWReply.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/MWScope.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/MWStateReceiver.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/MWSubscriber.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ObjectImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/OnlineAccountClientImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/OperationInfoImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/OptionSelectorFilterImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/PreviewQueryObject.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/PreviewQueryBaseImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/PreviewReplyImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/PreviewReplyObject.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/PreviewWidgetImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QueryBaseImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QueryCtrlImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QueryCtrlObject.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QueryMetadataImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QueryObject.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/RadioButtonsFilterImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/RatingFilterImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/RangeInputFilterImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Reaper.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/RegistryConfig.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/RegistryException.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/RegistryImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/RegistryObject.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ReplyImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ReplyObject.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ResultImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ResultReplyObject.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/RuntimeConfig.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/RuntimeImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/safe_strerror.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ScopeBaseImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ScopeConfig.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ScopeImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ScopeLoader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ScopeMetadataImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ScopeObject.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/SearchMetadataImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/SearchQueryBaseImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/SearchReplyImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/SettingsDB.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/StateReceiverObject.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/SwitchFilterImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ThreadPool.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/UniqueID.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Utils.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ValueSliderFilterImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ValueSliderLabelsImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/VariantBuilderImpl.cpp
)
set(UNITY_SCOPES_LIB_SRC ${UNITY_SCOPES_LIB_SRC} ${SRC} PARENT_SCOPE)

=== scopes/qt/CMakeLists.txt ===
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_ENABLE_QT_EXPERIMENTAL_")

set(SCOPES_QT_SRC
    ${CMAKE_CURRENT_SOURCE_DIR}/HttpAsyncReader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QActionMetadataImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QCannedQueryImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QCategorisedResultImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QCategoryImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QColumnLayoutImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QDepartmentImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QPreviewQueryBaseImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QPreviewReplyImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QPreviewWidgetImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QResultImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QScopeBaseAPIImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QScopeBaseImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QScopeVariant.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QSearchMetadataImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QSearchQueryBaseImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QSearchReplyImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QUtils.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal/QVariantBuilderImpl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/JsonAsyncReader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/JsonReader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QActionMetadata.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QCannedQuery.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QCategorisedResult.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QCategory.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QColumnLayout.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QDepartment.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QPreviewQueryBaseAPI.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QPreviewQueryBase.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QPreviewReply.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QPreviewWidget.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QResult.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QScopeBaseAPI.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QScopeBase.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QSearchMetadata.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QSearchQueryBaseAPI.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QSearchQueryBase.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QSearchReply.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QVariantBuilder.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/XmlAsyncReader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/XmlReader.cpp
    ${CMAKE_SOURCE_DIR}/include/unity/scopes/qt/internal/QScopeBaseAPIImpl.h
    ${CMAKE_SOURCE_DIR}/include/unity/scopes/qt/QPreviewQueryBaseAPI.h
    ${CMAKE_SOURCE_DIR}/include/unity/scopes/qt/QPreviewQueryBase.h
    ${CMAKE_SOURCE_DIR}/include/unity/scopes/qt/QPreviewReply.h
    ${CMAKE_SOURCE_DIR}/include/unity/scopes/qt/QScopeBase.h
    ${CMAKE_SOURCE_DIR}/include/unity/scopes/qt/QSearchQueryBaseAPI.h
    ${CMAKE_SOURCE_DIR}/include/unity/scopes/qt/QSearchQueryBase.h
    ${CMAKE_SOURCE_DIR}/include/unity/scopes/qt/QSearchReply.h
)

# -- libunity-scopes-qt --

include(CheckCXXSourceCompiles)
CHECK_CXX_SOURCE_COMPILES("#ifdef __clang__\n#else\n#error \"Not clang.\"\n#endif\nint main(int argc, char **argv) { return 0; }" IS_CLANG)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)


set(UNITY_SCOPES_QT_TEST ${UNITY_SCOPES_QT_LIB}-test)

find_package(PkgConfig REQUIRED)
find_package(Threads REQUIRED)

pkg_check_modules(
  SCOPE
  net-cpp>=1.1.0
  process-cpp
  REQUIRED
)

find_package(Qt5Core REQUIRED)

include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(
    ${CMAKE_BINARY_DIR}/include
)

add_library(
    ${UNITY_SCOPES_QT_LIB} SHARED
    ${SCOPES_QT_SRC}
)

add_library(
    ${UNITY_SCOPES_QT_TEST} SHARED
    ${SCOPES_QT_SRC}
)

qt5_use_modules(
    ${UNITY_SCOPES_QT_LIB}

    Core
)

qt5_use_modules(
    ${UNITY_SCOPES_QT_TEST}

    Core
)

#set(LIBS unity-scopes-qt)

target_link_libraries(
    ${UNITY_SCOPES_QT_LIB}
    ${UNITY_SCOPES_LIB}
    net-cpp
)

target_link_libraries(
    ${UNITY_SCOPES_QT_TEST}
    ${UNITY_SCOPES_LIB}
    net-cpp
)

set_target_properties(${UNITY_SCOPES_QT_LIB} PROPERTIES
    VERSION ${UNITY_SCOPES_QT_FULL_VERSION}
    SOVERSION ${UNITY_SCOPES_QT_SOVERSION})

set_target_properties(${UNITY_SCOPES_QT_TEST} PROPERTIES
    VERSION ${UNITY_SCOPES_QT_FULL_VERSION}
    SOVERSION ${UNITY_SCOPES_QT_SOVERSION})

set(ldflags "")

# Clang sanitizers don't work if --no-undefined is given as a linker argument.
if(NOT IS_CLANG)
    set(ldflags "-Wl,--no-undefined")
endif()

set_target_properties(${UNITY_SCOPES_QT_TEST} PROPERTIES LINK_FLAGS "${ldflags}")

# export the library name so the unit test can access
set(TESTLIBS_QT ${UNITY_SCOPES_QT_TEST} CACHE STRING "Qt test library with internal symbols visible" FORCE)
set(LIB_QT ${UNITY_SCOPES_QT_LIB} CACHE STRING "Qt library" FORCE)


# We compile with all symbols visible by default.
set(symbol_map "${CMAKE_SOURCE_DIR}/src/scopes/qt/${UNITY_SCOPES_QT_LIB}.map")
set_target_properties(${UNITY_SCOPES_QT_LIB} PROPERTIES
                      LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}")
set_target_properties(${UNITY_SCOPES_QT_LIB} PROPERTIES LINK_DEPENDS ${symbol_map})

install(TARGETS ${UNITY_SCOPES_QT_LIB} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})


#
# Documentation
#
# Pass -DDEVEL_DOCS=ON to cmake for more detailed documentation

option(DEVEL_DOCS "Enable detailed Doxygen documentation")

find_package(Doxygen)
find_program(DOT_EXECUTABLE dot /usr/bin)
if (NOT DOXYGEN_FOUND OR NOT DOT_EXECUTABLE)
    message(WARNING "Cannot generate documentation: doxygen and/or graphviz not found")
else()
    configure_file(${PROJECT_SOURCE_DIR}/doc/Doxyfile-scopes-qt.in ${PROJECT_BINARY_DIR}/doc/Doxyfile-scopes-qt @ONLY IMMEDIATE)
    add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/doc-scopes-qt/index.html
                       COMMAND ${DOXYGEN_EXECUTABLE} ${PROJECT_BINARY_DIR}/doc/Doxyfile-scopes-qt
                       DEPENDS ${PROJECT_BINARY_DIR}/doc/Doxyfile-scopes-qt
                               ${CMAKE_BINARY_DIR}/include/unity/scopes/qt)
    add_custom_target(doc-scopes-qt ALL DEPENDS ${PROJECT_BINARY_DIR}/doc-scopes-qt/index.html)
    install(DIRECTORY ${PROJECT_BINARY_DIR}/doc-scopes-qt/unity-scopes-qt
            DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/doc)
endif()

=== scopes/scope-A/CMakeLists.txt ===
set(symbol_map "${CMAKE_CURRENT_SOURCE_DIR}/scope-A.map")

add_library(scope-A MODULE scope-A.cpp)
# Add_dependencies should be used sparingly. In this case we need the global
# header to be generated before we start building the client binary.
# We also need the scoperegistry and scoperunner to be up-to-date.
add_dependencies(scope-A globalheader)
add_dependencies(scope-A scoperegistry scoperunner)
set_target_properties(scope-A PROPERTIES
                      LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}")
set_target_properties(scope-A PROPERTIES LINK_DEPENDS ${symbol_map})

configure_file(scope-A.ini.in scope-A.ini)

=== debian/changelog ===
unity-scopes-api (1.0.4+16.04.20160402.4-0ubuntu1) xenial; urgency=medium

  [ Marcus Tomlinson ]
  * Simplify debian/control munging. Look for clang-format as opposed to
    clang-format-3.x. Added missing initializations to TypedScopeFixture
    (Bug #1542906). Allow clients to specify authentication parameters
    (Bug #1554040). (LP: #1554040, #1542906)

  [ Michi Henning ]
  * Fixed incorrect generation of Replaces: and Conflicts: entries in
    debian/control for xenial. Fixed incorrect library soname for vivid.

 -- Marcus Tomlinson <marcus.tomlinson@canonical.com>  Sat, 02 Apr 2016 03:24:17 +0000

unity-scopes-api (1.0.4+16.04.20160317-0ubuntu1) xenial; urgency=medium

  [ Pawel Stolowski ]
  * New RangeInputFilter.

  [ Michi Henning ]
  * Changed ABI compliance testing to use abigail.

  [ CI Train Bot ]
  * No-change rebuild.

 -- Michael Zanetti <michael.zanetti@canonical.com>  Thu, 17 Mar 2016 22:35:17 +0000

unity-scopes-api (1.0.3+16.04.20160209-0ubuntu2) xenial; urgency=medium

  * No-change rebuild for zeromq3 transition.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 14 Mar 2016 22:39:01 +0100

unity-scopes-api (1.0.3+16.04.20160209-0ubuntu1) xenial; urgency=medium

  [ Michi Henning ]
  * Bumped micro version.

  [ CI Train Bot ]
  * No-change rebuild.

 -- Rodney Dawes <ci-train-bot@canonical.com>  Tue, 09 Feb 2016 15:15:15 +0000

unity-scopes-api (1.0.2+16.04.20151218.2-0ubuntu1) xenial; urgency=medium

  [ Michi Henning ]
  * Changed version number generation to use a common script. Removed
    symbols files because we are now using abi-compliance-checker.

  * Replaced global dummy loggers for testing with heap-allocated
    instances to avoid crash due to global destructor ordering (LP: #1472755).

  [ CI Train Bot ]
  * No-change rebuild.

 -- Pawel Stolowski <ci-train-bot@canonical.com>  Fri, 18 Dec 2015 11:42:03 +0000

unity-scopes-api (1.0.2+15.10.20151009-0ubuntu1) wily; urgency=medium

  [ CI Train Bot ]
  * New rebuild forced.

  [ Pawel Stolowski ]
  * Store scopes package version in /var/lib/.../version file for fast
    retrieval from the shell plugin.

 -- Pawel Stolowski <ci-train-bot@canonical.com>  Fri, 09 Oct 2015 09:12:00 +0000

unity-scopes-api (1.0.2+15.10.20150921-0ubuntu1) wily; urgency=medium

  [ Pawel Stolowski ]
  * Loop through each argument of the custom scope runner command and ensure
    that all path arguments are absolute.
  * Protect all JsonCppNode::get_node() methods with a "if (!root_) throw;"
    check (Fixes LP: #1494796).
  * Merged devel.

  [ CI Train Bot ]
  * debian/libunity-scopes.symbols.in: update to released version.
  * New rebuild forced.

 -- Pawel Stolowski <ci-train-bot@canonical.com>  Mon, 21 Sep 2015 13:32:17 +0000

unity-scopes-api (1.0.1+15.10.20150915.1-0ubuntu1) wily; urgency=medium

  [ Michi Henning ]
  * Consolidate debian packaging for Vivid and Wily, so we don't
    need to keep to separate series for the gcc 5 ABI break.

  [ CI Train Bot ]
  * debian/libunity-scopes.symbols.in: update to released version.
  * New rebuild forced.

  [ Alejandro J. Cura ]
  * Add docs for the table widget

 -- CI Train Bot <ci-train-bot@canonical.com>  Tue, 15 Sep 2015 11:20:24 +0000

unity-scopes-api (1.0.1+15.10.20150826-0ubuntu1) wily; urgency=medium

  [ Pawel Stolowski ]
  * Added support for preview widget updates via ActivationResponse.

  [ CI Train Bot ]
  * New rebuild forced.

 -- CI Train Bot <ci-train-bot@canonical.com>  Wed, 26 Aug 2015 08:59:51 +0000

unity-scopes-api (1.0.0-0ubuntu1) wily; urgency=medium

  * Changed package name and soname for toolchain update to gcc 5.0.

 -- Michi Henning <michi.henning@canonical.com>  Fri, 24 Jul 2015 15:12:14 +1000

unity-scopes-api (0.6.19+15.10.20150724.3-0ubuntu1) wily; urgency=medium

  [ Michi Henning ]
  * Updated standards version to 3.9.6 in debian/control. Removed
    copyonly from configure() calls because cmake 3.2.2 doesn't like it.
    Removed g++ dependency from debian/control because bzr bd emitted a
    warning.

 -- CI Train Bot <ci-train-bot@canonical.com>  Fri, 24 Jul 2015 12:52:52 +0000

unity-scopes-api (0.6.19+15.10.20150721-0ubuntu1) wily; urgency=medium

  [ Michi Henning ]
  * Removed gcc 4.9 dependency from debian/rules.

  [ Pawel Stolowski ]
  * Added missing #include needed for g++ 5.0.

 -- CI Train Bot <ci-train-bot@canonical.com>  Tue, 21 Jul 2015 05:14:09 +0000

unity-scopes-api (0.6.19+15.10.20150714-0ubuntu1) wily; urgency=medium

  [ CI Train Bot ]
  * New rebuild forced.

  [ Pawel Stolowski ]
  * Merged devel.

 -- CI Train Bot <ci-train-bot@canonical.com>  Tue, 14 Jul 2015 09:26:41 +0000

unity-scopes-api (0.6.19+15.10.20150708-0ubuntu1) wily; urgency=medium

  [ CI Train Bot ]
  * New rebuild forced.

  [ Pawel Stolowski ]
  * Fix handling of timeout in debug mode. Use mtime instead of inotify
    to detect settings changes. Revert delayed notification about scope
    removal.

 -- CI Train Bot <ci-train-bot@canonical.com>  Wed, 08 Jul 2015 14:35:44 +0000

unity-scopes-api (0.6.19+15.10.20150617.2-0ubuntu1) wily; urgency=medium

  [ Pawel Stolowski ]
  * Support UNITY_SCOPES_CONFIG_DIR environment variable.

  [ CI Train Bot ]
  * New rebuild forced.

 -- CI Train Bot <ci-train-bot@canonical.com>  Wed, 17 Jun 2015 16:30:27 +0000

unity-scopes-api (0.6.18+15.10.20150609.1-0ubuntu1) wily; urgency=medium

  [ Marcus Tomlinson ]
  * Allow child_scopes() and set_child_scopes() methods more time to
    execute as they read from and write to disk.
  * Added ChildScopes.Timeout configuration parameter to Zmq.ini

  [ Pawel Stolowski ]
  * Added API for activation of in-card result actions.

  [ CI Train Bot ]
  * debian/libunity-scopes3.symbols: update to released version.
  * New rebuild forced.

 -- CI Train Bot <ci-train-bot@canonical.com>  Tue, 09 Jun 2015 12:21:21 +0000

unity-scopes-api (0.6.17+15.10.20150526-0ubuntu1) wily; urgency=medium

  [ CI Train Bot ]
  * debian/libunity-scopes3.symbols: update to released version.



=== debian/control ===
# This file is autogenerated. DO NOT EDIT!
#
# Modifications should be made to control.in instead.
# This file is regenerated automatically by bileto.
#
Source: unity-scopes-api
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: abigail-tools | libabigail-tools,
               binutils,
               capnproto,
               click-dev (>= 0.2.2),
               cmake,
               dbus-test-runner,
               debhelper (>= 9),
               devscripts,
               doxygen,
               exuberant-ctags,
               google-mock,
               graphviz,
               libaccounts-glib-dev,
               libapparmor-dev,
               libboost-filesystem-dev,
               libboost-regex-dev,
               libboost-serialization-dev,
               libboost-thread-dev,
               libcapnp-dev (>= 0.4.0),
               libdbustest1-dev,
               libjsoncpp-dev,
               liblttng-ust-dev,
               libnet-cpp-dev (>= 1.2.0),
               libprocess-cpp-dev (>= 1.0.1),
               libsignon-glib-dev,
               libunity-api-dev (>= 7.80.7~),
               libzmq3-dev,
               libzmqpp-dev,
               lsb-release,
               lttng-tools,
               pkg-config,
               python3:any,
               python3-dbusmock,
               python-tornado,
               valgrind,
Standards-Version: 3.9.6
XS-Testsuite: autopkgtest
Section: libs
Homepage: https://launchpad.net/unity-scopes-api
# if you don't have have commit access to this branch but would like to upload
# directly to Ubuntu, don't worry: your changes will be merged back into the
# upstream branch
Vcs-Bzr: lp:unity-scopes-api
Vcs-Browser: https://code.launchpad.net/unity-scopes-api

Package: libunity-scopes1.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Replaces: libunity-scopes0,
          libunity-scopes3,
          libunity-scopes1,
          libunity-scopes2,
Conflicts: libunity-scopes0,
           libunity-scopes3,
           libunity-scopes1,
           libunity-scopes2,
Description: API for Unity scopes integration
 Library to integrate scopes with the Unity shell

Package: libunity-scopes-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libproperties-cpp-dev,
         libunity-api-dev,
         libunity-scopes1.0 (= ${binary:Version}),
         ${misc:Depends},
Description: Header files for Unity scopes API
 Library to integrate scopes with the Unity shell (dev files)

Package: libunity-scopes-cli
Section: devel
Architecture: any
Multi-Arch: foreign
Depends: libunity-scopes1.0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Client utility for Unity scopes API
 Commandline client utility for querying Unity scopes, useful for testing.

Package: libunity-scopes-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: Documentation for Unity scopes API
 Library to integrate scopes with the Unity shell (documentation)

Package: libunity-scopes-qt0.2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Qt library for Unity scopes API
 Library that integrates classes based on Qt for convenience

Package: libunity-scopes-qt-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libunity-scopes-dev (= ${binary:Version}),
         libunity-scopes-qt0.2 (= ${binary:Version}),
         libnet-cpp-dev (>=1.2.0),
         ${misc:Depends},
Description: Header files for Qt library for Unity scopes API
 Library that integrates classes based on Qt for convenience (dev files)

Package: libunity-scopes-qt-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: Documentation for Unity Qt library
 Library that integrates classes based on Qt for convenience (documentation)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DPKG_GENSYMBOLS_CHECK_LEVEL=4

# Skip tests on the archs they are known to be flaky with current configuration
testskip_architectures := powerpc ppc64el

%:
	dh $@ --parallel --fail-missing --with click

override_dh_auto_configure:
	dh_auto_configure -- -DLIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) -DCMAKE_INSTALL_LOCALSTATEDIR=/var

# Tests are not written to be run in parallel.
override_dh_auto_test:
ifeq (,$(filter $(testskip_architectures),$(DEB_HOST_ARCH)))
	dh_auto_test --max-parallel=1 -- ARGS="--verbose"
endif

override_dh_click:
	dh_click --name scope

override_dh_auto_clean:
	/bin/sh $(CURDIR)/debian/bileto_pre_release_hook
	dh_auto_clean

=== debian/tests/control ===
Tests: scopebuild
Depends: g++, pkg-config, libunity-scopes-dev
